﻿$(function(){
	window.App="Preference";
	loadLang();	
	loadData();
	$("#APPLY").click(function(){ toApply(); });
	$("#REFRESH").click(function(){	loadData();	});
});



function loadData(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/dyndns"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});		
}

function parseData(data){
	var hostname=[];
	$("hostname",data).each(function(){
		hostname.push($(this).text());
	});
	$("#hostname").val(hostname.join(','));
	$("#username").val($("username",data).text());
	$("#password").val($("password",data).text());
	var lastresp=$("lastresp",data).text();
	switch(lastresp){
		case 'badauth':
			$("#lastresp").html('<span domain="l10n" msgid="Preference_ddns_alert_badauth">'+$.l10n.__('Preference_ddns_alert_badauth')+'</span>');
		break;
		case 'nohost':
			$("#lastresp").html('<span domain="l10n" msgid="Preference_ddns_alert_nohost">'+$.l10n.__('Preference_ddns_alert_nohost')+'</span>');
		break;
		default:
			$("#lastresp").html(lastresp);
		break;
	}
}


function toApply(){
	if(!validate())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/set/dyndns"
		,cache:false
		,data:{
			hash:window.top.SessionID,
			hostname:$("#hostname").val().split(","),
			username:$("#username").val(),
			password:Crypt($('#password').val(),window.top.modulus,window.top.public)// $('#password').val()
			}
		,traditional:true
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			parseData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}

function validate(){
	var fields = [
		{
			method : 'required',
			value : $('#hostname').val(), 
			element : $('#hostname')[0],
			param : null, 
			errParam : $.l10n.__("Preference_register_text_name")
		}
	];

	return validateFields(fields);
}