﻿var GEARS={

init:function (){ 
	if(!window.top.google && !window.top.google.gears)return;
	window.top.gearsdesktop=google.gears.factory.create('beta.desktop');
	var drop,over,enter,leave;
	if ($.browser.mozilla) {
		drop=($.browser.version>='3.6')?"drop":"dragdrop";
		over='dragover';
		enter='dragenter';
		leave=($.browser.version>='3.6')?"dragleave":"dragexit";
	} else if ($.browser.msie) {
		drop='ondrop';
		over='ondragover';
		enter='ondragenter';
		leave='ondragleave';
	} else if ($.browser.safari||$.browser.chrome) {
		drop='drop';
		over='dragover';
		enter='dragenter';
		leave='dragleave';
	}
	else{		
		return;
	}

	var todo=($.browser.msie&&$.browser.version<'9.0')?'attachEvent':'addEventListener';
	$('body').get(0)[todo](drop, dragdrop, false);
	$('body').get(0)[todo](over, dragover, false);
	$('body').get(0)[todo](enter, dragenter, false);
	$('body').get(0)[todo](leave, dragleave, false);
	$('body')[0].unbind=function(){
		var todo=($.browser.msie&&$.browser.version<'9.0')?'detachEvent':'removeEventListener'; 
		$('body').get(0)[todo](drop, dragdrop, false);
		$('body').get(0)[todo](over, dragover, false);
		$('body').get(0)[todo](enter, dragenter, false);
		$('body').get(0)[todo](leave, dragleave, false);
	};
	
	GEARS.loaded=true;

	function dragover(event){
		if ($.browser.mozilla) {
			event.preventDefault();
		}
		else{
			event.returnValue = false;
		}
	}
	
	function dragenter(event){
		if ($.browser.mozilla) {
			event.preventDefault();
		}
		else{
			event.returnValue = false;
		}
		
	}
	
	function dragleave(event){
		
	}
	
	function dragdrop(event) {
		if(this.tasks&&this.tasks.preparing)return;
		var url;
		if ($.browser.mozilla) {
			url=event.dataTransfer.getData('text/uri-list');
			event.preventDefault();
			event.stopPropagation();
		}
		else{
			url=event.dataTransfer.getData('URL');
			event.returnValue = false;
		}
		dragleave();
		if(url&&url.indexOf(window.location.protocol+"//"+window.location.host)==0)return;
		var data = window.top.gearsdesktop.getDragData(event, 'application/x-gears-files');
		if(!data||data.files.length==0){return;}
		
		if(!window.top.uploadproxy.path){
			if(window.top.MyNAS.mainWin){ 
				var c=window.top.MyNAS.mainWin.content; 
			}
			else{
				var c=window.top.$('body')[0];
			}
			if(c.$UPLOAD&&c.$UPLOAD.hasClass('enabled'))window.top.uploadproxy.path=c.$curTreeNode[0].path; 
			window.top.uploadproxy.force=false;
		}

		if(window.top.uploadproxy.path&&window.top.uploadproxy.path!=='null'&&window.top.uploadproxy.path!=='')
			GEARS.addTasks(data.files, window.top.uploadproxy.path, window.top.uploadproxy.force);
		window.top.uploadproxy.path=null;
		window.top.uploadproxy.force=false;
	}
	//this.showWindow();
},


showWindow:function(){ 
	if(!window.top.MyNAS)window.top.loadApp('MyNAS',function(){window.top.MyNAS.upload();});
	else {	window.top.MyNAS.upload();	}
},


fileExsit:function(path){
	var list=$("#tasks tr");
	for(var i=0;i<list.length;i++){
		if($("td[_name='target'] div",list[i]).html()==path)return true;
	}
	return false;
},




prepareFiles:function(){
	this.tasks.processed++;
	if(this.tasks.processed>=this.tasks.total){
		this.tasks.preparing=false;
		return;
	}
	var file=this.tasks.files[this.tasks.processed];
	var path=this.tasks.path;
	if(file.blob.length>0){
		if(GEARS.fileExsit(path+file.name)){
			//alert( $.l10n.__('MyNAS_upload_alert_fileatlist').replace('{0}',file.name));
			GEARS.prepareFiles();
		}else{
			if(this.tasks.force){
				new GEARS.uploadTask(file, path);
				GEARS.prepareFiles();
			}else{
				if(!this.tasks.remember||this.tasks.remember==='no'||this.tasks.remember==='cancel'){
					window.top.System.isFileExist({
						path:path+encodeURI(file.name)
						,app:window.top.MyNAS
						,tasks:this.tasks
						,fn:function(){	
							var overwite=true;
							new GEARS.uploadTask(file, path);
							GEARS.prepareFiles();
						}
						,cancel:function(){
							GEARS.prepareFiles();
						}
						,cfm:GEARS.tasks.remember==='cancel'?false:true
					});		
				}else{
					new GEARS.uploadTask(file, path);
					GEARS.prepareFiles();
				}
			}
		}
	}else{
		alert($.l10n.__('MyNAS_upload_alert_filesize0').replace('{0}',file.name ));
		GEARS.prepareFiles();
	}
},







addTasks:function(files, path, force){
	this.showWindow();
	this.tasks={
		files:files
		,path:path
		,force:force
		,preparing:true
		,processed:-1
		,total:files.length
	};
	if(window.uploadtimer)window.clearInterval(window.uploadtimer);
	window.uploadtimer=window.setInterval(function(){
		if(GEARS.tasks.preparing)return;
		if(window.top.$("#tasks tr.uncomplete").length===0){
			window.clearInterval(window.uploadtimer);
			if(window.top.MyNAS)window.top.MyNAS.refreshWin(path);
		}else{
			window.top.$("#tasks tr.uncomplete.running").each(function(){
				if(!this.task.time)this.task.time=0;
				this.task.time++; 
				$("div.time",this).html(formatTime(this.task.time));
				if(this.task.v){
					if(!this.task.thischunk){this.task.thischunk=this.task.chunkstart;}
					if(this.task.thischunk<this.task.chunkend){
						this.task.thischunk += this.task.v; 
						var u=parseInt(this.task.thischunk);
						if(u>this.task.length)u=parseInt(this.task.length*.99); 
						this.task.$uploaded.html(formatBytes(u));				
						var p=parseInt((u/this.task.length)*100)+"%";
						this.task.$percentage.html(p);
						this.task.$progressbar.css({width:p}); 
						this.task.$speed.html(formatBytes(this.task.v)+'/s');
					}
				}
			});
		}
		if(window.top.$("#tasks tr").length===0){
			window.clearInterval(window.uploadtimer);
			window.top.MyNAS.uploadWin.closeWin();
		}
	},1000);
	this.prepareFiles();
},


uploadTask:function(file,path){
	//添加上传任务
	if(!$("#tasks")[0])return;
	this.initTask=function(){
		if(!window.taskID)window.taskID=0;
		window.taskID++;
		this.file=file;
		this.path=path;
		this.name=file.name;
		this.info={};
		this.blob=file.blob;
		this.length=file.blob.length;	
		//this.range={begin:0,end:0};	
		
		$("#tasks")[0].grid.addRow({
			id:'uploadtask'+window.taskID
			,operation:''
			,filename:this.name
			,progress:''
			,filesize:formatBytes(this.length)
			,uploaded:0
			,target:this.path+ this.name
			,time:'00:00:00:000'
			,speed:''
		});
		var tr=$("#tasks tr#uploadtask"+window.taskID);		
		
		var pause=document.createElement("a");pause.className="icon s12 play";
		var del=document.createElement("a");del.className="icon s12 remove";
			pause.style.cssText=del.style.cssText="padding:0;margin:0 5px;";
			pause.task=del.task=this;
			$(pause).click(function(){			this.task.pause();		});
			$(del).click(function(){			this.task.remove();	});		
		$("td[_name='operation'] div",tr).append(pause).append(del);
		$("td[_name='progress'] div",tr).html("<div class='progressbar' style='padding:0;margin:0;width:100%;'><div style='padding:0;margin:0;'></div><span>0%</span></div>");
	
		this.$pauseButton=$(pause);
		this.$progressbar=$("td[_name='progress'] div.progressbar div",tr);
		this.$uploaded=$("td[_name='uploaded'] div",tr);
		this.$speed=$("td[_name='speed'] div",tr);
		this.$percentage=$("td[_name='progress'] span",tr);
		this.$time=$("td[_name='time'] div",tr);
		this.$time.addClass("time");
		this.$target=$("td[_name='target'] div",tr);
		this.$task=tr;
		this.$task.addClass("uncomplete");
		tr[0].task=this;
		if($("#tasks tr.running").length==0)this.send();
	}
	
	//上传
	this.send=function(){ 
		if(this.request)this.request.abort();
		this.request=null;
		this.$pauseButton.removeClass('play').addClass('pause');
		this.$task.addClass("running");
		if(!this.starttime)this.starttime=new Date();
		if(this.endtime)this.thischunk=null;
		if(this.starttime&&this.endtime)this.v=this.chunk/((this.endtime-this.starttime)/1000);	
		this.starttime=new Date();
		this.endtime=null;
		this.chunk = (this.v)?parseInt(this.v*10):1024*512;	
		if(this.chunk<1024*512)this.chunk=1024*512;
		//if(this.chunk>=1024*1024*50)this.chunk=1024*1024*50;
		if(!this.chunkstart)this.chunkstart=0;
		
			this.chunkend=this.chunkstart+this.chunk-1; 
			if(this.chunkend>this.length-1)this.chunkend=this.length-1;
			
			var task=this;
			var request=window.top.google.gears.factory.create('beta.httprequest');			
			this.request=request;
	
			/*this.request.upload.onprogress = function(progressEvent){
				var c=progressEvent.lengthComputable;
				var t=progressEvent.total;
				var l=progressEvent.loaded;
			};*/
			
			this.request.onreadystatechange = function(){				
				switch(request.readyState){
					case 4:    //complete
						//alert(request.status+"_____"+request.getAllResponseHeaders()+"______"+request.responseText);
						var apierror=false; 
						if($.browser.msie){
							apierror=window.top.checkAPIError(request.responseText); 
							try{if(!apierror)var status=$('status',stringToXML(request.responseText)).text();}catch(e){}
							if(!status)status='200';
						}
						else {
							var status=request.status;
						}
						
						if(status=='201'||status=='204'||status=='1223'||status=='200'||status=='412'){
							apierror=false;
							if(status=='412')alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+status + ' wrong file format!') );		
							if(status=='200')apierror=window.top.checkAPIError(task.request.responseText);
						}
						else{
							apierror=true;
							alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+status ) );	
						}
						if(!apierror){
							task.chunkstart=task.chunkend+1; 
							if(task.chunkstart>task.length-1){
								task.$task.removeClass("uncomplete").removeClass("running");
								//task.$pauseButton[0].className="icon s12 ok";								
								task.remove();
								task.next();
							}
							else{
								task.endtime=new Date();
								task.$uploaded.html(formatBytes(task.chunkstart));
								var p=parseInt((task.chunkstart/task.length)*100)+"%";
								var p2=task.$percentage.html().replace('%','')-0;
								if(p>=p2){
									task.$percentage.html(p);
									task.$progressbar.css({width:p}); 
								}
								if(!task.$pauseButton.hasClass('play'))task.send();
								else task.request.abort();
							}
						}
						else{
							task.pause();
						}
					break;
				}
			}; 
			request.open( "POST", task.path+task.name  +'?streaming='+(($.browser.msie)?'false':'true') ); 
			if(window.top.SessionID)request.setRequestHeader('Session', window.top.SessionID); 
			request.setRequestHeader('Content-Range', 'bytes '+ task.chunkstart + '-' + task.chunkend + '/'+task.length);			
			request.send(task.blob.slice(task.chunkstart,(task.chunkend-task.chunkstart+1))); 		
			
	}
	
	
	
	//暂停任务
	this.pause=function(){
		if(this.$task.hasClass("uncomplete")){
			if(this.$pauseButton.hasClass('pause')){
				this.$pauseButton.removeClass("pause").addClass('play');
				this.$task.removeClass("running");
				this.request.abort();
			}
			else{				
				this.$pauseButton.removeClass("play").addClass('pause');
				this.$task.addClass("running");
				this.send();
			}
		}
	}
	
	
	
	//删除任务
	this.remove=function(){
		var bool=true; 
		if(this.$task.hasClass("uncomplete")){
			if(!confirm($.l10n.__('MyNAS_upload_alert_notcomplete'))){
				bool=false;
			}
		}
		if(bool){
			this.$task.remove();
			if(this.request)this.request.abort();
			if(this.send)this.send=null;
		}
	}
	
	
	//继续任务
	this.next=function(){
		if($("#tasks tr.running")>0)return;
		try{$("#tasks tr.uncomplete")[0].task.$pauseButton.click();}catch(e){}
	}
	
	//初始化新任务
	this.initTask();
}

}