﻿$(function(){	
	window.App="ImageViewer";
	loadLang();
	layout();
	bindEvent(); 
	loadData();
});




function layout(){
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:60
		,	north__spacing_open:0
		,	contentSelector:".data"
	}); 
	$('#toolbar').toolbar();
}

function loadData(){
	$("#pic").empty().html('<img src="../../Library/blank.gif" style="width:100px;height:100px;" class="loading"/>'); 
	var path=window.win.fromWinObject.path; 
	path=path+'?hash='+window.top.SessionID;
	var img=new Image();
	img.onload=function(){
		$("#pic").empty().append(img);
	}
	img.src=path;
}


function bindEvent(){
	$("li",'#top').addClass('enabled');
	$("#top li.ZOOMIN").click(function(){
		if(!$(this).hasClass('enabled'))return;
		toZoomIn();
	});
	
	$("#top li.ZOOMOUT").click(function(){
		if(!$(this).hasClass('enabled'))return;
		toZoomOut();
	});
}



function toZoomIn(){
		var $img=$("#pic img");
		var img=$img[0];
		if($img.hasClass('webview')&&$img.width()>=img.ow&&$img.height()>=img.oh){
			$('#waiting').show();
			img=new Image();
			
			img.onload=function(){
				$('#waiting').hide();
				$(img).width($img.width()).height($img.height());
				$(img).css({width:$img.width()*1.5, height:$img.height()*1.5});
				$('#pic').empty().append(img);	
				
			}
			img.src=$("#list li.selected").attr('path')+'?hash='+window.top.SessionID+'&login='+window.top.user+'&_='+new Date().getTime();
			img.className="slideimage";
			$('div.img',this).empty().html('<img src="../../Library/blank.gif" class="loading"/>'); 

		}else{
			$img.css({width:$img.width()*1.5, height:$img.height()*1.5});
		}
}

function toZoomOut(){
		var $img=$("#pic img");
		var img=$img[0];		
		var w=$img.width()/1.5;
		var h=$img.height()/1.5;
		if(w<10||h<10)return;
		$img.css({width:w, height:h});
}