﻿$(function(){
	window.App="MyNAS"; 
	loadLang();
	loadData();
});




function loadData(){
	var o=window.win.fromWinObject;
	window.obj=o;
	window.processed=-1;
	window.complete=0;
	window.error=0;
	var s=o.source;
	if(typeof(s)==='object'){
		window.total=s.length;
		doNext();
	}
	else{
		window.total=1;
		toDo(o.method,s,o.sourcepath,o.targetpath);
	}
}



function completed(){
	$('#completed').css({width:(window.complete/window.total*100)+'%'}); 
	if(window.complete>=window.total){ 
		var ps=[window.obj.targetpath,window.obj.sourcepath];
		var l=ps.length; 
		while(l--){
			var tp=ps[l];
			if(tp){
				if(typeof(tp)==='object'){
					tp.addClass('unknown');
					if(tp.hasClass('selected'))tp.click();
				}else{
					if(window.top.MyNAS){
						if(window.obj.method!=='DELETE'){
							window.top.MyNAS.refreshWin(window.obj.targetpath);
							//window.top.MyNAS.refreshWin(window.obj.sourcepath);
						}
					}
				}
			} 
		}
		if(window.obj.method==='DELETE')window.top.MyNAS.reloadWin(window.obj.sourcepath);
		if(window.error===0)window.setTimeout( function(){window.win.closeWin();}, 1000);
	}

}



function doNext(){
	completed();
	window.processed++;
	var o=window.obj;
	if(window.processed>=o.source.length)return;
	var s=o.source[window.processed];
	$('#path').html(decodeURIComponent(o.targetpath+getDisplayNameFromPath(s)));
	if((!window.remember||window.remember==='no'||window.remember==='cancel')&&(o.method==='COPY'||(o.method==='MOVE'&&o.targetpath!==window.top.root+'home/.trash/'))){
		window.top.System.isFileExist({
			path:o.targetpath+encodeURI(getDisplayNameFromPath(s))
			,app:window.top.MyNAS
			,tasks:window
			,fn:function(){
				var overwite=true;
				toDo(o.method,s,o.sourcepath,o.targetpath,overwite);
				doNext();
			}
			,cancel:function(){
				window.complete++;
				doNext();
			}
			,cfm:window.remember==='cancel'?false:true
		});
				
	}else{
		if(!window.remember){
			toDo(o.method,s,o.sourcepath,o.targetpath);
		}
		if(window.remember==='replace'){
			var overwite=true;
			toDo(o.method,s,o.sourcepath,o.targetpath,overwite)
		}
		doNext();
	}
}


function toDo(method,file,sourcepath,targetpath,overwite){
	var option = {
		depth: "infinity"
		,overwrite: overwite?true:false
		,locktoken: ''					
	};
	var handler = {
		onComplete: function(result){
			window.complete++;
			$('#completed').css({width:(window.complete/window.total*100)+'%'}); 
			//$('#source').html('');
			if(method==='DELETE'){
				if(sourcepath===window.top.root+'home/.trash/'){window.top.MyNAS.trashWin.content.g.deletefile(file);}
				else {window.top.MyNAS.mainWin.content.g.deletefile(file);}
			}
			if(method==='MOVE'&&sourcepath){
				if(sourcepath===window.top.root+'home/.trash/'){window.top.MyNAS.trashWin.content.g.deletefile(file);}
				else {window.top.MyNAS.mainWin.content.g.deletefile(file);}
			}
			completed();
		}
	}
	var filename=getDisplayNameFromPath(file,true);
	var fileheader=(targetpath===window.top.root+'home/.trash/')?new Date().getTime()+'_':'';
	if(fileheader!==''&&method==='MOVE'){ 
		window.top.webdav.PUT({}, targetpath + '.' + fileheader.replace('_',''), {content:file,content_type:'text/plain'} );
	}

	//$('#source').html(getDisplayNameFromPath(file,true));
	if(method!=='DELETE'){
		if(sourcepath===window.top.root+'home/.trash/'){ 
			option.destination=targetpath+filename.replace(filename.split('_')[0]+'_',''); 
		}
		else if(targetpath===window.top.root+'home/.trash/') {option.destination=targetpath+fileheader+filename;}
		else {option.destination=targetpath+filename;}

	}
	
	if(/\/$/.test(file)){
		option.destination=option.destination+'/';
		handler.onSuccess=function(result){
			if(sourcepath===window.top.root+'home/.trash/'){ 
				window.top.webdav.DELETE({}, window.top.root+'home/.trash/.'+filename.split('_')[0], {});
			}
		};
		
	}	
	else{
		var tw=getThumbPath(file);
		var thumbnail=tw.thumbnail;
		var webview=tw.webview;
		handler.onSuccess=function(result){
			if(method!=='COPY'){
				window.top.webdav.DELETE({}, thumbnail, {});
				window.top.webdav.DELETE({}, webview, {});
			}
			if( sourcepath===(window.top.root+'home/.trash/') ){
				window.top.webdav.DELETE({}, window.top.root+'home/.trash/.'+filename.split('_')[0], {});
			}
		};
	}
	handler.onError=function(result){
		window.error++;
		$('#result').show().append('<div class="failed">'+decodeURIComponent(filename)+'</div>');
	};
	option.destination=window.top.location.protocol+"//"+window.top.location.host+option.destination;
	window.top.webdav[method](handler, file, option);
}