﻿$(function(){
	window.App="Preference";
	loadLang();	
	loadData();
	$("#APPLY").click(function(){ toRegister(); });
});



function loadData(){
	var dl=window.top.$.l10n.__('global_link_portal');
	$("#domainlink").attr("href",dl).html(dl); 

	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/info"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			var url=$("register",data).text();
			$("#name").val(url);
			window.top.NASinfo.registername=url;
		}
		,error:function(data){
			$("#waiting").hide();
			//alert(data.responseText);
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});		
}

//--------------------------------注册-------------------------------------------------------------
function toRegister(){
	if(!validate())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/register"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,name:$("#name").val()
			,host:$.l10n.__('global_link_registerhost')
			,port:$.l10n.__('global_link_registerport')
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			window.top.NASinfo.registername=$("#name").val();
			//var dl=window.top.location.protocol+"//"+window.top.NASinfo.registername+'.'+$.l10n.__('global_link_domainname')+'/';
			//$("#domainlink").attr("href",dl).html(dl); 			
			alert ( $.l10n.__("Preference_register_alert_ok") );

		}
		,error:function(data){
			$("#waiting").hide();
			//alert(data.responseText);
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
	
	
	
}

function validate(){
	var fields = [
		{
			method : 'required',
			value : $('#name').val(), 
			element : $('#name')[0],
			param : null, 
			errParam : $.l10n.__("Preference_register_text_name")
		},
		{
			method : 'regex',
			value : $('#name').val(), 
			element : $('#name')[0],
			param : '^[a-zA-Z0-9-]{3,32}$', 
			errParam : $.l10n.__("Preference_register_text_name")
		}
	];

	return validateFields(fields);
}


