﻿$(function(){
	window.App="Preference";
	loadLang();	
	loadData();
	bindEvent();
});


//-----------------------------------------------------------------------------------------------------------------------
function bindEvent(){	
	$("#APPLY").click(function(){	toApply();	});	
	$("#REFRESH").click(function(){	loadData();	});	
}



//-----------------------------------------------------------------------------------------------------------------------
function loadData(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/upnp"
		,cache:false
		,data:{
			hash:window.top.SessionID
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}


function parseData(data){
	var addr=$('addr',data).text();
	var port=$('port',data).text();
	$("#port").val(port);
	if(addr!==''){
		window.top.NASinfo.upnp=addr+':'+port;
		$("#addr").html(window.top.NASinfo.upnp).attr('href','http://'+window.top.NASinfo.upnp+'/');
	}
	else{
		window.top.NASinfo.upnp='';
		$("#addr").html('no mapping').attr('src','#');
	}
}

function toApply(){
	if(!validate())return;	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/set/upnp"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,port:$("#port").val()
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			//parseData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}


function validate(){
	var fields = [];
	if($("#check").attr('checked')){
		fields.push({
			method : 'required',
			value : $('#port').val(), 
			element : $('#port')[0],
			param : null, 
			errParam :$.l10n.__("Preference_upnp_text_port")
		},
		{
			method : 'range',
			value : $('#port').val(), 
			element : $('#port')[0],
			param : [1,65535], 
			errParam : [$.l10n.__("Preference_upnp_text_port"),1,65535]
		});
	}

	return validateFields(fields);
}
